// FIDO.CH  defines the starting offset of any fixed header parameter in a
//          standard fido message packet.


#define FIDO_FROMUSERNAME        0
#define FIDO_TOUSERNAME         36
#define FIDO_SUBJECT            72
#define FIDO_DATETIME          144
#define FIDO_TIMESREAD         164
#define FIDO_DESTNODE          166
#define FIDO_ORIGNODE          168
#define FIDO_COST              170
#define FIDO_ORIGNET           172
#define FIDO_DESTNET           174
#define FIDO_DESTZONE          176
#define FIDO_ORIGZONE          178
#define FIDO_DESTPOINT         180
#define FIDO_ORIGPOINT         182
#define FIDO_REPLYTO           184
#define FIDO_ATTRIBUTE         186
#define FIDO_NEXTREPLY         188

