#xcommand DEFAULT <v1> TO <x1> [, <vn> TO <xn> ]                        ;
          =>                                                            ;
          IF <v1> == NIL ; <v1> := <x1> ; END                           ;
          [; IF <vn> == NIL ; <vn> := <xn> ; END ]

function DEMO()

LOCAL DIRARY,NUMFILES,X,Y,MSG_PARTS:={},THE_FILE,NUM_KLUDGES
LOCAL NUM_SEENBY, NUM_PATHS
LOCAL MSGID_PTR, MSGID_LINE
LOCAL REPLY_PTR, REPLY_LINE
LOCAL SPAT

clear screen

DIRARY := DIRECTORY('*.msg')
NUMFILES := LEN(DIRARY)

@ 1,0 say 'Number of files = '+str(NUMFILES)

for X := 1 to NUMFILES
  
  THE_FILE := DIRARY[X,1]
  
  MSG_PARTS := FIDOREAD(THE_FILE)
  
  FIDOWRITE('test.txt',MSG_PARTS)
  
  clear screen
  ? THE_FILE
  
  ? '     From: '+ MSG_PARTS[1] 
  MSGID_PTR := ASCAN(MSG_PARTS[20],'MSGID')
  if MSGID_PTR > 0
    MSGID_LINE := MSG_PARTS[20,MSGID_PTR]
    SPAT := at(' ',MSGID_LINE)
    MSGID_LINE := substr(MSGID_LINE,SPAT+1)
    SPAT := at(' ',MSGID_LINE)
    MSGID_LINE := left(MSGID_LINE,SPAT-1)
    if ':' $ MSGID_LINE
      ?? ' of '+MSGID_LINE
    endif
  endif
  
  ? '       To: '+ MSG_PARTS[2]
  REPLY_PTR := ASCAN(MSG_PARTS[20],'REPLY')
  if REPLY_PTR > 0
    REPLY_LINE := MSG_PARTS[20,REPLY_PTR]
    SPAT := at(' ',REPLY_LINE)
    REPLY_LINE := substr(REPLY_LINE,SPAT+1)
    SPAT := at(' ',REPLY_LINE)
    REPLY_LINE := left(REPLY_LINE,SPAT-1)
    if ':' $ REPLY_LINE
      ?? ' of '+REPLY_LINE
    endif
  endif
  
  ? '  Subject: '+ MSG_PARTS[3]
  
  ? '     Date: '+ dtoc(MSG_PARTS[4])
  ? '     Time: '+ MSG_PARTS[5]
  ?
  ? '  Reply To ', MSG_PARTS[16]
  ? '       See ', MSG_PARTS[18]
  ?
  ? ' Attribute ', MSG_PARTS[17]
  ?
  //  ? '* destZone ', MSG_PARTS[12],'  * origZone ', MSG_PARTS[13]
  ? '   destNet ', MSG_PARTS[11],'    origNet  ', MSG_PARTS[10]
  ? '  destNode ', MSG_PARTS[ 7],'    origNode ', MSG_PARTS[ 8]
  //  ? '* destPoint', MSG_PARTS[14],'  * origPoint', MSG_PARTS[15]
  ?
  ? ' timesRead ', MSG_PARTS[ 6]
  ?
  ? '      cost ', MSG_PARTS[ 9]
  inkey(0)
  
  clear screen
  NUM_KLUDGES := LEN(MSG_PARTS[20])
  ? 'Number of Kludge Lines = '+str(NUM_KLUDGES)
  ?
  if NUM_KLUDGES > 0
    for Y := 1 to NUM_KLUDGES
      ? MSG_PARTS[20,Y]
    next
  endif
  ?
  ?
  NUM_SEENBY := LEN(MSG_PARTS[21])
  ? "Number of Seen-by's = "+str(NUM_SEENBY)
  ?
  if NUM_SEENBY > 0
    for Y := 1 to NUM_SEENBY
      ? MSG_PARTS[21,Y]
    next
  endif
  ?
  ?
  NUM_PATHS := LEN(MSG_PARTS[22])
  ? "Number of Path's = "+str(NUM_PATHS)
  ?
  if NUM_PATHS > 0
    for Y := 1 to NUM_PATHS
      ? MSG_PARTS[22,Y]
    next
  endif
  ?
  ? MSG_PARTS[22]
  inkey(0)
  
  clear screen
  ? STRTRAN(MSG_PARTS[19],chr(13),chr(13)+chr(10))   // BODY OF text
  inkey(0)
  
next

return NIL

************************************************** 

function FIDOREAD(THE_FILE)

LOCAL HANDLE := FOPEN(THE_FILE,0)

LOCAL FRONT, MFROM, MTO, MSUBJECT, MDATE, MTIME, BUFFER, XBUFFER
LOCAL TIMESREAD, DESTNODE ,ORIGNODE ,COST ,ORIGNET ,DESTNET  
LOCAL DESTZONE ,ORIGZONE ,DESTPOINT, ORIGPOINT, REPLYTO, ATTRIBUTE
LOCAL NEXTREPLY, FIRSTPART, LASTPART, CRLFAT, message, ORIGIN
LOCAL CRAT, STRIPAT, BYTESREAD, PTH, SBY, TEMP_SEENBY, TEMP_PATH

LOCAL KLUDGE := {}
LOCAL SEENBY := {}
LOCAL path := {}
LOCAL BUFFLEN := 2048

// read IN THE FIRST 108 BYTES.

FSEEK(HANDLE,0,0)
FRONT := space(144)
FREAD(HANDLE,@FRONT,144)

// PARSE FIRST 144 BYTES INTO from/to/SUBJECT

MFROM := left(FRONT,36)
MTO := substr(FRONT,37,36)
MSUBJECT := right(FRONT,72)

// REPOSITION to OFFSET 144 and read date and time

FSEEK(HANDLE,144,0)

MDATE := space(11)

FREAD(HANDLE,@MDATE,11)
MTIME := space(8)
FREAD(HANDLE,@MTIME,8)

// REPOSITION to OFFSET 164 and read 26 BYTES.

FSEEK(HANDLE,164,0)

XBUFFER := space(26)
FREAD(HANDLE,@XBUFFER,26)

// PARSE THE 26 BYTES INTO 13 LO-BYTE/HI-BYTE HEX to decimal CONVERSIONS
// to EXTRACT THEIR VALUES

TIMESREAD := HEXWRD2VAL(substr(XBUFFER, 1,2))
DESTNODE  := HEXWRD2VAL(substr(XBUFFER, 3,2))
ORIGNODE  := HEXWRD2VAL(substr(XBUFFER, 5,2))
COST      := HEXWRD2VAL(substr(XBUFFER, 7,2))
ORIGNET   := HEXWRD2VAL(substr(XBUFFER, 9,2))
DESTNET   := HEXWRD2VAL(substr(XBUFFER,11,2))

// BEGIN FIDO OPTIONAL (THEY DON't seem to do much at this level)

DESTZONE  := HEXWRD2VAL(substr(XBUFFER,13,2))
ORIGZONE  := HEXWRD2VAL(substr(XBUFFER,15,2))
DESTPOINT := HEXWRD2VAL(substr(XBUFFER,17,2))
ORIGPOINT := HEXWRD2VAL(substr(XBUFFER,19,2))

// END FIDO OPTIONAL

REPLYTO   := HEXWRD2VAL(substr(XBUFFER,21,2))
ATTRIBUTE := HEXWRD2VAL(substr(XBUFFER,23,2))
NEXTREPLY := HEXWRD2VAL(substr(XBUFFER,25,2))

// REPOSITION to BEGINNING OF message BLOCK at OFFSET 190

FSEEK(HANDLE,190,0)

// read IN WHATEVER IS left INTO THE message BLOCK

message := ''
BYTESREAD := BUFFLEN
do while BYTESREAD == BUFFLEN
  BUFFER := space(BUFFLEN)
  BYTESREAD := FREAD(HANDLE,@BUFFER,BUFFLEN)
  message += left(BUFFER,BYTESREAD)
enddo

FCLOSE(HANDLE)

// THIS STRIPS THE path KLUDGES off THE END OF THE message BLOCK
// and PUTS THEM IN AN ARRAY

PTH := at('PATH',message)
if PTH > 0
  TEMP_PATH := substr(message,PTH)   // GRAB THE path
  message := left(message,PTH-1)     // CUT IT off END OF message
  CRAT := at(chr(13)+chr(10),TEMP_PATH)
  do while CRAT > 0
    if left(TEMP_PATH,5) == 'PATH'
      AADD(path,left(TEMP_PATH,CRAT-1))
    endif
    TEMP_PATH := substr(TEMP_PATH,CRAT+2)
    CRAT := at(chr(13),TEMP_PATH)
  enddo
endif

// THIS STRIPS THE SEEN-BY's off the end of the message block
// and PUTS THEM IN AN ARRAY.

SBY := at('SEEN-BY',message)
if SBY > 0
  TEMP_SEENBY := substr(message,SBY)  // GRAB THE SEEN-BY
  message := left(message,SBY-1)      // CUT IT off THE END OF THE message
  CRAT := at(chr(13)+chr(10),TEMP_SEENBY)
  do while CRAT > 0
    if left(TEMP_SEENBY,7) == 'SEEN-BY'
      AADD(SEENBY,left(TEMP_SEENBY,CRAT-1))
    endif
    TEMP_SEENBY := substr(TEMP_SEENBY,CRAT+2)
    CRAT := at(chr(13),TEMP_SEENBY)
  enddo
endif

// THIS STRIPS THE IFNA KLUDGE LINES off OF THE FRONT OF THE message BLOCK
// and PUTS THEM IN AN ARRAY

do while left(message,1) == ''
  CRAT := at(chr(13),message)
  AADD(KLUDGE,left(message,CRAT))    // GRAB THE IFNA KLUDGE
  message := substr(message,CRAT+1)  // CUT IT off THE FRON OF THE message
enddo

MDATE := ctod(STRZERO(CTOMONTH(substr(MDATE,4,3)),2) + '/' + ;
              left(MDATE,2) + '/' + ;
              substr(MDATE,8,2))

return { MFROM     ,;    //  1
         MTO       ,;    //  2
         MSUBJECT  ,;    //  3
         MDATE     ,;    //  4
         MTIME     ,;    //  5
         TIMESREAD ,;    //  6
         DESTNODE  ,;    //  7
         ORIGNODE  ,;    //  8
         COST      ,;    //  9
         ORIGNET   ,;    // 10
         DESTNET   ,;    // 11
         DESTZONE  ,;    // 12
         ORIGZONE  ,;    // 13
         DESTPOINT ,;    // 14
         ORIGPOINT ,;    // 15
         REPLYTO   ,;    // 16
         ATTRIBUTE ,;    // 17
         NEXTREPLY ,;    // 18
         message   ,;    // 19
         KLUDGE    ,;    // 20
         SEENBY    ,;    // 21
         path      }     // 22

************************************************** 

function HEXWRD2VAL( TWO_BYTES )

LOCAL LOBYTE := asc( TWO_BYTES )
LOCAL HIBYTE := asc( right( TWO_BYTES ,1 ) )

return LOBYTE + ( 256 * HIBYTE )

**************************************************

function CTOMONTH(TXT)

return ASCAN({"Jan","Feb","Mar","Apr","May","Jun",;
              "Jul","Aug","Sep","Oct","Nov","Dec"} ,TXT)

function MONTHTOC(MTH)

LOCAL MONTH_ARRY := {"Jan","Feb","Mar","Apr","May","Jun",;
                     "Jul","Aug","Sep","Oct","Nov","Dec"}

return MONTH_ARRY[MTH]

************************************************** 

function FIDOWRITE( FILENAME, MSG_PARTS )


LOCAL HANDLE := FCREATE(FILENAME,0)
LOCAL month,day,year,X,TEXTDATE

default msg_parts[20] to {}
default msg_parts[21] to {}
default msg_parts[22] to {}

FWRITE(HANDLE,PAD(MSG_PARTS[1],36))
FWRITE(HANDLE,PAD(MSG_PARTS[2],36))
FWRITE(HANDLE,PAD(MSG_PARTS[3],72))

TEXTDATE := dtoc(MSG_PARTS[4])

month := MONTHTOC(val(left(TEXTDATE,2)))
day := substr(TEXTDATE,4,2)
year := substr(TEXTDATE,7,2)

FWRITE(HANDLE,day + ' ' + month + ' ' + year + '  ')
FWRITE(HANDLE,PAD(MSG_PARTS[5],9))

for X := 6 to 18
  FWRITE(HANDLE,chr(SWLOWBYTE(MSG_PARTS[X]))+chr(SWHIGHBYTE(MSG_PARTS[X])))
next

if LEN(MSG_PARTS[20]) > 0
  for X := 1 to LEN(MSG_PARTS[20])
    FWRITE(HANDLE,MSG_PARTS[20,X]+chr(13))
  next
endif

FWRITE(HANDLE,MSG_PARTS[19])

if LEN(MSG_PARTS[21]) > 0
  for X := 1 to LEN(MSG_PARTS[21])
    FWRITE(HANDLE,MSG_PARTS[21,X]+chr(13)+chr(10))
  next
endif

if LEN(MSG_PARTS[22]) > 0
  for X := 1 to LEN(MSG_PARTS[22])
    FWRITE(HANDLE,MSG_PARTS[22,X]+chr(13)+chr(10))
  next
endif

FWRITE(HANDLE,CHR(0))  // Null terminated.

FCLOSE(HANDLE)

return NIL

**************************************************

function fido_incr(file_name)

local handle, bytes, timesread

handle := fopen(file_name,2)

fseek(handle,164,0)

bytes := '  '
fread(handle,@bytes,2)

TIMESREAD := HEXWRD2VAL(bytes)

timesread ++

fseek(handle,164,0)

FWRITE(HANDLE,chr(SWLOWBYTE(timesread))+chr(SWHIGHBYTE(timesread)))

fclose(handle)

return NIL

*************

function fido_headr(file_name,offset)

local handle, bytes

handle := fopen(file_name,2)
fseek(handle,offset,0)
bytes := '  '
fread(handle,@bytes,2)
fclose(handle)

return HEXWRD2VAL(bytes)

*********************************

function fido_headw(file_name,offset,value)

local handle, bytes

handle := fopen(file_name,2)
fseek(handle,offset,0)
FWRITE(HANDLE,chr(SWLOWBYTE(value))+chr(SWHIGHBYTE(value)))
fclose(handle)

return NIL

