FUNCTION convert

local dirary,numfiles,x,parts:={},the_File

CLEAR SCREEN

dirchange('h:\bbs\conf\clipper')

dirary := directory('temp\*.msg')
numfiles := len(dirary)

filedelete('sbc*.txt')

@ 1,0 SAY 'Number of files = '+STR(numfiles)

USE confrnc ALIAS conference
ZAP
INDEX ON msg_no TO msg_no
INDEX ON ref_no TO ref_no

FOR x := 1 TO numfiles
  
  dirchange('temp')
  
  the_file := alltrim(STR(x))+'.MSG'
  
  @ 5,0 SAY the_file
  
  parts := msgsplit(the_file)
  
  dirchange('..')
  
  APPEND BLANK
  
  REPLACE conference->TO      WITH parts[1]
  REPLACE conference->FROM    WITH parts[2]
  REPLACE conference->subject WITH parts[3]
  
  day := left(parts[4],2)
  month := strzero(ctomonth(substr(parts[4],4,3)),2)
  year := substr(parts[4],8,2)
  
  replace conference->date    with ctod(day+'/'+month+'/'+year)
  REPLACE conference->TIME    WITH parts[5]
  REPLACE conference->msg_no  WITH x
  
  memowrit('sbc'+alltrim(STR(x))+'.txt',parts[6])
NEXT

RETURN nil


static FUNCTION msgsplit(the_file)

local handle := fopen(the_file,0)

local front

fseek(handle,0,0)
front := SPACE(108)
fread(handle,@FRONT,108)

mfrom := left(front,36)
mto := substr(front,37,36)
msubject := right(front,36)

? mfrom
? mto
? msubject


mDATE := SPACE(11)
fseek(handle,144,0)
fread(handle,@mDATE,11)

? 'Date',mdate

mTIME := SPACE(8)
fread(handle,@mTIME,8)

? 'Time',mtime

fseek(handle,191,0)

bytesread := 1024
donestrip := .F.

outstring := ''

DO WHILE bytesread == 1024
  
  buffer := SPACE(1024)
  bytesread := fread(handle,@buffer,1024)
  
  IF !donestrip
    
    DO WHILE .T.
      donestrip := .T.
      stripat := AT(CHR(13)+CHR(1),buffer)
      IF stripat > 0
        buffer := SUBSTR(buffer,stripat + 2)
      ELSE
        EXIT
      ENDIF  
    ENDDO
    
    crat := AT(CHR(13),buffer)
    buffer := SUBSTR(buffer,crat+1)
    
  ENDIF
  
  outstring += buffer
  
ENDDO

fclose(handle)

outstring := strtran(outstring,CHR(13),CHR(13)+CHR(10))

origin := AT(' * Origin',outstring)

firstpart := LEFT(outstring,origin-1)
lastpart := SUBSTR(outstring,origin)
crlfat := AT(CHR(13)+CHR(10),lastpart)


RETURN {mFROM,mto,msubject,mDATE,mTIME,firstpart+LEFT(lastpart,crlfat+1)}

