#include 'FIDO.CH'
#include 'common.ch'

function fido_set(message)

default message to ''

if file(message) .and. !empty(message)
  clear screen
  if verify({'The current attribute is '+str(fido_headr(message,FIDO_ATTRIBUTE)),;
             'do you want to change it?'})
             
    newvalue := ask_for('Enter the new attribute value',0,'999')
    if !lastkey() == 27
      fido_headw(message,FIDO_ATTRIBUTE,newvalue)
    endif
  endif

else
  ? 'file '+message+' not found.'
  ?
endif

return NIL

*************

function fido_headr(file_name,offset)

local handle, bytes

handle := fopen(file_name,2)
fseek(handle,offset,0)
bytes := '  '
fread(handle,@bytes,2)
fclose(handle)

return HEXWRD2VAL(bytes)

*********************************

function fido_headw(file_name,offset,value)

local handle, bytes

handle := fopen(file_name,2)
fseek(handle,offset,0)
FWRITE(HANDLE,chr(SWLOWBYTE(value))+chr(SWHIGHBYTE(value)))
fclose(handle)

return NIL
function HEXWRD2VAL( TWO_BYTES )

LOCAL LOBYTE := asc( TWO_BYTES )
LOCAL HIBYTE := asc( right( TWO_BYTES ,1 ) )

return LOBYTE + ( 256 * HIBYTE )

